diff --git a/web/pgadmin/misc/cloud/static/js/CloudWizard.jsx b/web/pgadmin/misc/cloud/static/js/CloudWizard.jsx
index d176ba1aa..5bb0340fe 100644
--- a/web/pgadmin/misc/cloud/static/js/CloudWizard.jsx
+++ b/web/pgadmin/misc/cloud/static/js/CloudWizard.jsx
@@ -14,17 +14,19 @@ import { Box, Table, TableBody, TableCell, TableHead, TableRow, Paper } from '@m
 import { makeStyles } from '@material-ui/core/styles';
 import Wizard from '../../../../static/js/helpers/wizard/Wizard';
 import WizardStep from '../../../../static/js/helpers/wizard/WizardStep';
-import {FormFooterMessage, MESSAGE_TYPE, InputToggle } from '../../../../static/js/components/FormComponents';
+import {FormFooterMessage, MESSAGE_TYPE } from '../../../../static/js/components/FormComponents';
 import getApiInstance from '../../../../static/js/api_instance';
-import SchemaView from '../../../../static/js/SchemaView';
 import Alertify from 'pgadmin.alertifyjs';
 import PropTypes from 'prop-types';
-import {CloudInstanceDetailsSchema, CloudDBCredSchema, DatabaseSchema} from './cloud_db_details_schema.ui';
-import { isEmptyString } from 'sources/validators';
 import pgAdmin from 'sources/pgadmin';
-import { getNodeAjaxOptions, getNodeListById } from 'pgbrowser/node_ajax';
 import { commonTableStyles } from '../../../../static/js/Theme';
 import clsx from 'clsx';
+import ToggleButtons from './cloud_components';
+import { PrimaryButton } from '../../../../static/js/components/Buttons';
+import {AwsCredentials, AwsInstanceDetails, AwsDatabaseDetails, validateCloudStep1,
+  validateCloudStep2, validateCloudStep3, getAWSSummary} from './aws';
+import {BigAnimalInstance, BigAnimalDatabase, validateBigAnimal, getBigAnimalSummary,
+  validateBigAnimalStep2, validateBigAnimalStep3} from './biganimal';
 
 const useStyles = makeStyles(() =>
   ({
@@ -33,7 +35,12 @@ const useStyles = makeStyles(() =>
       display: 'flex',
     },
     messagePadding: {
-      flex: 2.5
+      paddingTop: '10px',
+      flex: 2.5,
+    },
+    buttonMarginEDB: {
+      position: 'relative',
+      top: '20%',
     },
     toggleButton: {
       height: '100px',
@@ -49,7 +56,15 @@ const useStyles = makeStyles(() =>
     tableCell: {
       padding: '9px',
       paddingLeft: '11px',
-    }
+    },
+    summaryContainer: {
+      flexGrow: 1,
+      minHeight: 0,
+      overflow: 'auto',
+    },
+    boxText: {
+      paddingBottom: '5px'
+    },
   }),
 );
 
@@ -61,17 +76,24 @@ export default function CloudWizard({ nodeInfo, nodeData }) {
   const [currentStep, setCurrentStep] = React.useState('');
   const [selectionVal, setCloudSelection] = React.useState('');
   const [errMsg, setErrMsg] = React.useState('');
-  const [cloudInstanceDetailsInstance, setCloudInstanceDetailsInstance] = React.useState();
-  const [cloudDBCredInstance, setCloudDBCredInstance] = React.useState();
-  const [cloudDBInstance, setCloudDBInstance] = React.useState();
   const [cloudInstanceDetails, setCloudInstanceDetails] = React.useState({});
   const [cloudDBCred, setCloudDBCred] = React.useState({});
   const [cloudDBDetails, setCloudDBDetails] = React.useState({});
   const [callRDSAPI, setCallRDSAPI] = React.useState({});
   const [hostIP, setHostIP] = React.useState('127.0.0.1/32');
+  const [cloudProvider, setCloudProvider] = React.useState('');
+  const [verificationIntiated, setVerificationIntiated] = React.useState(false);
+  const [bigAnimalInstanceData, setBigAnimalInstanceData] = React.useState({});
+  const [bigAnimalDatabaseData, setBigAnimalDatabaseData] = React.useState({});
+  const [summary, setFinalSummary] = React.useState([]);
+
   const axiosApi = getApiInstance();
 
+  const [verificationURI, setVerificationURI] = React.useState('');
+  const [verificationCode, setVerificationCode] = React.useState('');
+
   React.useEffect(() => {
+    if (cloudProvider != 'rds') return;
     let _url = url_for('cloud.get_host_ip') ;
     axiosApi.get(_url)
       .then((res) => {
@@ -82,139 +104,33 @@ export default function CloudWizard({ nodeInfo, nodeData }) {
       .catch((error) => {
         Alertify.error(gettext(`Error while getting the host ip: ${error.response.data.errormsg}`));
       });
-  }, []);
-
-  React.useEffect(() => {
-    if (callRDSAPI == 2) {
-      const cloudDBInstanceSchema = new CloudInstanceDetailsSchema({
-        version: ()=>getNodeAjaxOptions('get_aws_db_versions', pgAdmin.Browser.Nodes['server'], nodeInfo, nodeData, {
-          useCache:false,
-          cacheNode: 'server',
-          customGenerateUrl: ()=>{
-            return url_for('cloud.get_aws_db_versions');
-          }
-        }),
-        getInstances: (engine, reload, options) =>
-        {
-          return new Promise((resolve, reject)=>{
-            const api = getApiInstance();
-            var _url = url_for('cloud.get_aws_db_instances') ;
-
-            if (engine) _url += '?eng_version=' + engine;
-            if (reload || options === undefined || options.length == 0) {
-              api.get(_url)
-                .then(res=>{
-                  let data = res.data.data;
-                  resolve(data);
-                })
-                .catch((err)=>{
-                  reject(err);
-                });
-            } else {
-              resolve(options);
-            }
-          });
-        },
-        instance_type: ()=>getNodeAjaxOptions('get_aws_db_instances', pgAdmin.Browser.Nodes['server'], nodeInfo, nodeData, {
-          useCache:false,
-          cacheNode: 'server',
-          customGenerateUrl: ()=>{
-            return url_for('cloud.get_aws_db_instances');
-          }
-        }),
-        server_groups: ()=>getNodeListById(pgAdmin.Browser.Nodes['server_group'], nodeInfo, nodeData),
-      }, {
-        gid: nodeInfo['server_group']._id,
-        hostIP: hostIP,
-      });
-      setCloudInstanceDetailsInstance(cloudDBInstanceSchema);
-    }
-  }, [callRDSAPI]);
-
-  React.useEffect(() => {
-    const cloudDBCredSchema = new CloudDBCredSchema({
-      regions: ()=>getNodeAjaxOptions('get_aws_regions', pgAdmin.Browser.Nodes['server'], nodeInfo, nodeData, {
-        useCache:false,
-        cacheNode: 'server',
-        customGenerateUrl: ()=>{
-          return url_for('cloud.get_aws_regions');
-        }
-      }),
-    });
-    setCloudDBCredInstance(cloudDBCredSchema);
-
-    const cloudDBSchema = new DatabaseSchema({
-      server_groups: ()=>getNodeListById(pgAdmin.Browser.Nodes['server_group'], nodeInfo, nodeData),
-    },
-    {
-      gid: nodeInfo['server_group']._id,
-    }
-    );
-    setCloudDBInstance(cloudDBSchema);
-
-  }, []);
+  }, [cloudProvider]);
 
   const wizardStepChange = (data) => {
     setCurrentStep(data.currentStep);
   };
 
-  const validateCloudStep1 = (cloudDBCred) => {
-    let isError = false;
-    if (isEmptyString(cloudDBCred.aws_access_key) || isEmptyString(cloudDBCred.aws_secret_access_key)) {
-      isError = true;
-    }
-    return isError;
-  };
-
-  const validateCloudStep2 = (cloudInstanceDetails, host_ip) => {
-    let isError = false;
-    if (isEmptyString(cloudInstanceDetails.aws_name) ||
-    isEmptyString(cloudInstanceDetails.aws_db_version) || isEmptyString(cloudInstanceDetails.aws_instance_type) ||
-    isEmptyString(cloudInstanceDetails.aws_storage_type)|| isEmptyString(cloudInstanceDetails.aws_storage_size)) {
-      isError = true;
-    }
-
-    if(cloudInstanceDetails.aws_storage_type == 'io1' && isEmptyString(cloudInstanceDetails.aws_storage_IOPS)) {
-      isError = true;
-    }
-    if (isEmptyString(cloudInstanceDetails.aws_public_ip)) cloudInstanceDetails.aws_public_ip = host_ip;
-    return isError;
-  };
-
-  const validateCloudStep3 = (cloudDBDetails) => {
-    let isError = false;
-    if (isEmptyString(cloudDBDetails.aws_db_name) ||
-    isEmptyString(cloudDBDetails.aws_db_username) || isEmptyString(cloudDBDetails.aws_db_password)) {
-      isError = true;
-    }
-    if (isEmptyString(cloudDBDetails.aws_db_port)) cloudDBDetails.aws_db_port = 5432;
-    if (isEmptyString(cloudDBDetails.gid)) cloudDBDetails.gid = nodeInfo['server_group']._id;
-    return isError;
-  };
-
-  const getStorageType = (cloudInstanceDetails) => {
-    let _storage_type = 'General Purpose SSD (gp2)',
-      _io1 = undefined;
-
-    if(cloudInstanceDetails.aws_storage_type == 'gp2') _storage_type = 'General Purpose SSD (gp2)';
-    else if(cloudInstanceDetails.aws_storage_type == 'io1') {
-      _storage_type = 'Provisioned IOPS SSD (io1)';
-      _io1 = cloudInstanceDetails.aws_storage_IOPS;
+  const onSave = () => {
+    var _url = url_for('cloud.deploy_on_cloud'),
+      post_data = {};
+
+    if (cloudProvider == 'rds') {
+      post_data = {
+        gid: nodeInfo.server_group._id,
+        cloud: cloudProvider,
+        secret: cloudDBCred,
+        instance_details:cloudInstanceDetails,
+        db_details: cloudDBDetails
+      };
+    } else {
+      post_data = {
+        gid: nodeInfo.server_group._id,
+        cloud: cloudProvider,
+        instance_details:bigAnimalInstanceData,
+        db_details: bigAnimalDatabaseData
+      };
     }
-    else if(cloudInstanceDetails.aws_storage_type == 'magnetic') _storage_type = 'Magnetic';
-
-    return [_io1, _storage_type];
-  };
 
-  const onSave = () => {
-    var _url = url_for('cloud.deploy_on_cloud');
-    const post_data = {
-      gid: nodeInfo.server_group._id,
-      cloud: selectionVal,
-      secret: cloudDBCred,
-      instance_details:cloudInstanceDetails,
-      db_details: cloudDBDetails
-    };
     axiosApi.post(_url, post_data)
       .then((res) => {
         pgAdmin.Browser.Events.trigger('pgadmin:browser:tree:add', res.data.data.node, {'server_group': nodeInfo['server_group']});
@@ -228,21 +144,49 @@ export default function CloudWizard({ nodeInfo, nodeData }) {
 
   const disableNextCheck = () => {
     setCallRDSAPI(currentStep);
-    let isError = false;
-    switch (currentStep) {
-    case 0:
-      setCloudSelection('rds');
-      break;
-    case 1:
-      isError = validateCloudStep1(cloudDBCred);
-      break;
-    case 2:
-      isError = validateCloudStep2(cloudInstanceDetails, hostIP);
-      break;
-    case 3:
-      isError = validateCloudStep3(cloudDBDetails);
+    let isError = (cloudProvider == '');
+    switch(cloudProvider) {
+    case 'rds':
+      switch (currentStep) {
+      case 0:
+        setCloudSelection('rds');
+        break;
+      case 1:
+        isError = validateCloudStep1(cloudDBCred);
+        break;
+      case 2:
+        isError = validateCloudStep2(cloudInstanceDetails, hostIP);
+        break;
+      case 3:
+        isError = validateCloudStep3(cloudDBDetails, nodeInfo);
+        break;
+      case 4:
+        setFinalSummary(getAWSSummary(cloudProvider, cloudInstanceDetails, cloudDBDetails));
+        break;
+      default:
+        break;
+      }
       break;
-    default:
+    case 'biganimal':
+      switch (currentStep) {
+      case 0:
+        setCloudSelection('biganimal');
+        break;
+      case 1:
+        isError = !verificationIntiated;
+        break;
+      case 2:
+        isError = validateBigAnimalStep2(bigAnimalInstanceData);
+        break;
+      case 3:
+        isError = validateBigAnimalStep3(bigAnimalDatabaseData, nodeInfo);
+        break;
+      case 4:
+        setFinalSummary(getBigAnimalSummary(cloudProvider, bigAnimalInstanceData, bigAnimalDatabaseData));
+        break;
+      default:
+        break;
+      }
       break;
     }
     return isError;
@@ -250,7 +194,7 @@ export default function CloudWizard({ nodeInfo, nodeData }) {
 
   const onBeforeNext = (activeStep) => {
     return new Promise((resolve, reject)=>{
-      if(activeStep == 1) {
+      if(activeStep == 1 && cloudProvider == 'rds') {
         setErrMsg([MESSAGE_TYPE.INFO, 'Validating credentials...']);
         var _url = url_for('cloud.verify_credentials');
         const post_data = {
@@ -271,61 +215,59 @@ export default function CloudWizard({ nodeInfo, nodeData }) {
             setErrMsg([MESSAGE_TYPE.ERROR, 'Error while checking cloud credentials']);
             reject();
           });
-      } else {
+      } else if(activeStep == 0 && cloudProvider == 'biganimal') {
+        setErrMsg([MESSAGE_TYPE.INFO, 'Getting EDB BigAnimal verification URL...']);
+        validateBigAnimal()
+          .then((res) => {
+            setVerificationURI(res);
+            setVerificationCode(res.substring(res.indexOf('=')+1));
+            setErrMsg(['', '']);
+            resolve();
+          })
+          .catch((error) => {
+            setErrMsg([MESSAGE_TYPE.ERROR, gettext(error)]);
+            reject();
+          });
+      }
+      else {
         resolve();
       }
     });
   };
 
-  const onDialogHelp = () => {
-    window.open(url_for('help.static', { 'filename': 'cloud_deployment.html' }), 'pgadmin_help');
-  };
-
-  function createData(name, value) {
-    return { name, value };
-  }
-
-  let cloud = '';
-
-  switch (selectionVal) {
-  case 'rds':
-    cloud = 'Amazon RDS';
-    break;
-  case 'azure':
-    cloud = 'Azure PostgreSQL';
-    break;
-  case 'biganimal':
-    cloud = 'EDB Big Animal';
-    break;
-  }
-
-  const rows1 = [
-    createData('Cloud', cloud),
-    createData('Instance name', cloudInstanceDetails.aws_name),
-    createData('Public IP', cloudInstanceDetails.aws_public_ip),
-  ];
+  const authenticateBigAnimal = () => {
+    var loading_icon_url = url_for(
+      'static', { 'filename': 'img/loading.gif'}
+    );
 
-  const rows2 = [
-    createData('PostgreSQL version', cloudInstanceDetails.aws_db_version),
-    createData('Instance type', cloudInstanceDetails.aws_instance_type),
-  ];
+    setErrMsg([MESSAGE_TYPE.INFO, 'EDB BigAnimal authentication process is in progress...<img src="' + loading_icon_url + '" alt="' + gettext('Loading...') + '">']);
+    window.open(verificationURI, 'edb_bibanimal_authentication');
+    let _url = url_for('cloud.biganimal_verification_ack') ;
+    const myInterval = setInterval(() => {
+      axiosApi.get(_url)
+        .then((res) => {
+          if (res.data && res.data.success == 1 ) {
+            setErrMsg([MESSAGE_TYPE.SUCCESS, 'Authentication completed successfully. Click the Next button to proceed.']);
+            setVerificationIntiated(true);
+            clearInterval(myInterval);
+          }
+          else if (res.data && res.data.success == 0 &&  res.data.errormsg == 'access_denied') {
+            setErrMsg([MESSAGE_TYPE.INFO, 'Verification failed. Access Denied...']);
+            setVerificationIntiated(false);
+            clearInterval(myInterval);
+          }
+        })
+        .catch((error) => {
+          setErrMsg([MESSAGE_TYPE.ERROR, gettext(`Error while verification EDB BigAnimal: ${error.response.data.errormsg}`)]);
+        });
+    }, 1000);
 
-  let _storage_type = getStorageType(cloudInstanceDetails);
+  };
 
-  const rows3 = [
-    createData('Storage type', _storage_type[1]),
-    createData('Allocated storage', cloudInstanceDetails.aws_storage_size + ' GiB'),
-  ];
-  if (_storage_type[0] !== undefined) {
-    rows3.push(createData('Provisioned IOPS', _storage_type[0]));
-  }
 
-  const rows4 = [
-    createData('Database name', cloudDBDetails.aws_db_name),
-    createData('Username', cloudDBDetails.aws_db_username),
-    createData('Password', 'xxxxxxx'),
-    createData('Port',  cloudDBDetails.aws_db_port),
-  ];
+  const onDialogHelp = () => {
+    window.open(url_for('help.static', { 'filename': 'cloud_deployment.html' }), 'pgadmin_help');
+  };
 
   const onErrClose = React.useCallback(()=>{
     setErrMsg([]);
@@ -341,6 +283,22 @@ export default function CloudWizard({ nodeInfo, nodeData }) {
     ));
   };
 
+  const summaryHeader = ['Cloud Details', 'Version and Instance Details', 'Storage Details', 'Database Details'];
+  const tableRows = summary.map((item, index) => {
+    return (
+      <Table key={index} className={clsx(tableClasses.table)}>
+        <TableHead>
+          <TableRow>
+            <TableCell colSpan={2}>{gettext(summaryHeader[index])}</TableCell>
+          </TableRow>
+        </TableHead>
+        <TableBody>
+          {displayTableRows(item)}
+        </TableBody>
+      </Table>
+    );
+  });
+
   return (
     <>
       <Wizard
@@ -353,107 +311,70 @@ export default function CloudWizard({ nodeInfo, nodeData }) {
         beforeNext={onBeforeNext}>
         <WizardStep stepId={0}>
           <Box className={classes.messageBox}>
-            <Box className={classes.messagePadding}>{gettext('Deploy on Amazon RDS cloud.')}</Box>
+            <Box className={classes.messagePadding}>{gettext('Select any option to deploy on cloud.')}</Box>
           </Box>
           <Box className={classes.messageBox}>
-            <InputToggle
-              value='rds'
-              options={[{'label': gettext('Amazon RDS'), value: 'rds'}]}
-              className={classes.toggleButton}
-              onChange={(value) => {
-                setCloudSelection(value);}
-              }
-            >
-            </InputToggle>
+            <ToggleButtons cloudProvider={cloudProvider} setCloudProvider={setCloudProvider}
+              options={[{'label': 'Amazon RDS', value: 'rds'}, {'label': 'EDB BigAnimal', value: 'biganimal'}]}
+            ></ToggleButtons>
           </Box>
           <Box className={classes.messageBox}>
             <Box className={classes.messagePadding}>{gettext('More cloud providers are coming soon...')}</Box>
           </Box>
+          <FormFooterMessage type={errMsg[0]} message={errMsg[1]} onClose={onErrClose} />
         </WizardStep>
         <WizardStep stepId={1} >
-          {cloudDBCredInstance &&
-            <SchemaView
-              formType={'dialog'}
-              getInitData={() => { /*This is intentional (SonarQube)*/ }}
-              viewHelperProps={{ mode: 'create' }}
-              schema={cloudDBCredInstance}
-              showFooter={false}
-              isTabView={false}
-              onDataChange={(isChanged, changedData) => {
-                setCloudDBCred(changedData);
-              }}
-            />
-          }
+          <Box className={classes.buttonMarginEDB}>
+            {cloudProvider == 'biganimal' && <Box className={classes.messageBox}>
+              <Box>{gettext('The verification code to authenticate the pgAdmin to EDB BigAnimal is: ')} <strong>{verificationCode}</strong>
+                <br/>{gettext('By clicking the below button, you will be redirected to the EDB BigAnimal authentication page in a new tab.')}
+              </Box>
+            </Box>}
+            {cloudProvider == 'biganimal' && <PrimaryButton onClick={authenticateBigAnimal}>
+              {gettext('Click here to authenticate yourself to EDB BigAnimal')}
+            </PrimaryButton>}
+            {cloudProvider == 'biganimal' && <Box className={classes.messageBox}>
+              <Box ></Box>
+            </Box>}
+          </Box>
+          {cloudProvider == 'rds' && <AwsCredentials cloudProvider={cloudProvider} nodeInfo={nodeInfo} nodeData={nodeData} setCloudDBCred={setCloudDBCred}/>}
           <FormFooterMessage type={errMsg[0]} message={errMsg[1]} onClose={onErrClose} />
         </WizardStep>
         <WizardStep stepId={2} >
-          {cloudInstanceDetailsInstance &&
-            <SchemaView
-              formType={'dialog'}
-              getInitData={() => { /*This is intentional (SonarQube)*/ }}
-              viewHelperProps={{ mode: 'create' }}
-              schema={cloudInstanceDetailsInstance}
-              showFooter={false}
-              isTabView={false}
-              onDataChange={(isChanged, changedData) => {
-                setCloudInstanceDetails(changedData);
-              }}
-            />
-          }
+          {cloudProvider == 'rds' && callRDSAPI == 2 && <AwsInstanceDetails
+            cloudProvider={cloudProvider}
+            nodeInfo={nodeInfo}
+            nodeData={nodeData}
+            setCloudInstanceDetails={setCloudInstanceDetails}
+            hostIP={hostIP} /> }
+          {cloudProvider == 'biganimal' && callRDSAPI == 2 && <BigAnimalInstance
+            cloudProvider={cloudProvider}
+            nodeInfo={nodeInfo}
+            nodeData={nodeData}
+            setBigAnimalInstanceData={setBigAnimalInstanceData}
+            hostIP={hostIP}
+          /> }
         </WizardStep>
         <WizardStep stepId={3} >
-          {cloudDBInstance &&
-            <SchemaView
-              formType={'dialog'}
-              getInitData={() => { /*This is intentional (SonarQube)*/ }}
-              viewHelperProps={{ mode: 'create' }}
-              schema={cloudDBInstance}
-              showFooter={false}
-              isTabView={false}
-              onDataChange={(isChanged, changedData) => {
-                setCloudDBDetails(changedData);
-              }}
-            />
+          {cloudProvider == 'rds' && <AwsDatabaseDetails
+            cloudProvider={cloudProvider}
+            nodeInfo={nodeInfo}
+            nodeData={nodeData}
+            setCloudDBDetails={setCloudDBDetails}
+          />
+          }
+          {cloudProvider == 'biganimal' && callRDSAPI == 3 && <BigAnimalDatabase
+            cloudProvider={cloudProvider}
+            nodeInfo={nodeInfo}
+            nodeData={nodeData}
+            setBigAnimalDatabaseData={setBigAnimalDatabaseData}
+          />
           }
         </WizardStep>
         <WizardStep stepId={4} >
           <Box className={classes.boxText}>{gettext('Please review the details before creating the cloud instance.')}</Box>
           <Paper variant="outlined" elevation={0} className={classes.summaryContainer}>
-            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
-              <TableBody>
-                {displayTableRows(rows1)}
-              </TableBody>
-            </Table>
-            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
-              <TableHead>
-                <TableRow>
-                  <TableCell colSpan={2}>{gettext('Version and Instance Details')}</TableCell>
-                </TableRow>
-              </TableHead>
-              <TableBody>
-                {displayTableRows(rows2)}
-              </TableBody>
-            </Table>
-            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
-              <TableHead>
-                <TableRow>
-                  <TableCell colSpan={2}>{gettext('Storage Details')}</TableCell>
-                </TableRow>
-              </TableHead>
-              <TableBody>
-                {displayTableRows(rows3)}
-              </TableBody>
-            </Table>
-            <Table aria-label="simple table" className={clsx(tableClasses.table)}>
-              <TableHead>
-                <TableRow>
-                  <TableCell colSpan={2}>{gettext('Database Details')}</TableCell>
-                </TableRow>
-              </TableHead>
-              <TableBody>
-                {displayTableRows(rows4)}
-              </TableBody>
-            </Table>
+            {tableRows}
           </Paper>
         </WizardStep>
       </Wizard>
diff --git a/web/pgadmin/misc/cloud/static/js/aws.js b/web/pgadmin/misc/cloud/static/js/aws.js
new file mode 100644
index 000000000..844b42db1
--- /dev/null
+++ b/web/pgadmin/misc/cloud/static/js/aws.js
@@ -0,0 +1,243 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import React from 'react';
+import pgAdmin from 'sources/pgadmin';
+import { getNodeAjaxOptions, getNodeListById } from 'pgbrowser/node_ajax';
+import {CloudInstanceDetailsSchema, CloudDBCredSchema, DatabaseSchema} from './cloud_db_details_schema.ui';
+import SchemaView from '../../../../static/js/SchemaView';
+import url_for from 'sources/url_for';
+import getApiInstance from '../../../../static/js/api_instance';
+import { isEmptyString } from 'sources/validators';
+import PropTypes from 'prop-types';
+
+// AWS credentials
+export function AwsCredentials(props) {
+  const [cloudDBCredInstance, setCloudDBCredInstance] = React.useState();
+
+  React.useMemo(() => {
+    const cloudDBCredSchema = new CloudDBCredSchema({
+      regions: ()=>getNodeAjaxOptions('get_aws_regions', pgAdmin.Browser.Nodes['server'], props.nodeInfo, props.nodeData, {
+        useCache:false,
+        cacheNode: 'server',
+        customGenerateUrl: ()=>{
+          return url_for('cloud.get_aws_regions');
+        }
+      }),
+    });
+    setCloudDBCredInstance(cloudDBCredSchema);
+  }, [props.cloudProvider]);
+
+  return  <SchemaView
+    formType={'dialog'}
+    getInitData={() => { /*This is intentional (SonarQube)*/ }}
+    viewHelperProps={{ mode: 'create' }}
+    schema={cloudDBCredInstance}
+    showFooter={false}
+    isTabView={false}
+    onDataChange={(isChanged, changedData) => {
+      props.setCloudDBCred(changedData);
+    }}
+  />;
+}
+AwsCredentials.propTypes = {
+  nodeInfo: PropTypes.object,
+  nodeData: PropTypes.object,
+  cloudProvider: PropTypes.string,
+  setCloudDBCred: PropTypes.func,
+};
+
+// AWS Instance Details
+export function AwsInstanceDetails(props) {
+  const [cloudInstanceDetailsInstance, setCloudInstanceDetailsInstance] = React.useState();
+
+  React.useMemo(() => {
+    const cloudDBInstanceSchema = new CloudInstanceDetailsSchema({
+      version: ()=>getNodeAjaxOptions('get_aws_db_versions', pgAdmin.Browser.Nodes['server'], props.nodeInfo, props.nodeData, {
+        useCache:false,
+        cacheNode: 'server',
+        customGenerateUrl: ()=>{
+          return url_for('cloud.get_aws_db_versions');
+        }
+      }),
+      getInstances: (engine, reload, options) =>
+      {
+        return new Promise((resolve, reject)=>{
+          const api = getApiInstance();
+          var _url = url_for('cloud.get_aws_db_instances') ;
+
+          if (engine) _url += '?eng_version=' + engine;
+          if (reload || options === undefined || options.length == 0) {
+            api.get(_url)
+              .then(res=>{
+                let data = res.data.data;
+                resolve(data);
+              })
+              .catch((err)=>{
+                reject(err);
+              });
+          } else {
+            resolve(options);
+          }
+        });
+      },
+      instance_type: ()=>getNodeAjaxOptions('get_aws_db_instances', pgAdmin.Browser.Nodes['server'], props.nodeInfo, props.nodeData, {
+        useCache:false,
+        cacheNode: 'server',
+        customGenerateUrl: ()=>{
+          return url_for('cloud.get_aws_db_instances');
+        }
+      }),
+      server_groups: ()=>getNodeListById(pgAdmin.Browser.Nodes['server_group'], props.nodeInfo, props.nodeData),
+    }, {
+      gid: props.nodeInfo['server_group']._id,
+      hostIP: props.hostIP,
+    });
+    setCloudInstanceDetailsInstance(cloudDBInstanceSchema);
+  }, [props.cloudProvider]);
+
+
+  return  <SchemaView
+    formType={'dialog'}
+    getInitData={() => { /*This is intentional (SonarQube)*/ }}
+    viewHelperProps={{ mode: 'create' }}
+    schema={cloudInstanceDetailsInstance}
+    showFooter={false}
+    isTabView={false}
+    onDataChange={(isChanged, changedData) => {
+      props.setCloudInstanceDetails(changedData);
+    }}
+  />;
+}
+AwsInstanceDetails.propTypes = {
+  nodeInfo: PropTypes.object,
+  nodeData: PropTypes.object,
+  cloudProvider: PropTypes.string,
+  hostIP: PropTypes.string,
+  setCloudInstanceDetails: PropTypes.func,
+};
+
+// AWS Database Details
+export function AwsDatabaseDetails(props) {
+  const [cloudDBInstance, setCloudDBInstance] = React.useState();
+
+  React.useMemo(() => {
+    const cloudDBSchema = new DatabaseSchema({
+      server_groups: ()=>getNodeListById(pgAdmin.Browser.Nodes['server_group'], props.nodeInfo, props.nodeData),
+    },
+    {
+      gid: props.nodeInfo['server_group']._id,
+    }
+    );
+    setCloudDBInstance(cloudDBSchema);
+
+  }, [props.cloudProvider]);
+
+  return <SchemaView
+    formType={'dialog'}
+    getInitData={() => { /*This is intentional (SonarQube)*/ }}
+    viewHelperProps={{ mode: 'create' }}
+    schema={cloudDBInstance}
+    showFooter={false}
+    isTabView={false}
+    onDataChange={(isChanged, changedData) => {
+      props.setCloudDBDetails(changedData);
+    }}
+  />;
+}
+AwsDatabaseDetails.propTypes = {
+  nodeInfo: PropTypes.object,
+  nodeData: PropTypes.object,
+  cloudProvider: PropTypes.string,
+  setCloudDBDetails: PropTypes.func,
+};
+
+export function validateCloudStep1(cloudDBCred) {
+  let isError = false;
+  if (isEmptyString(cloudDBCred.aws_access_key) || isEmptyString(cloudDBCred.aws_secret_access_key)) {
+    isError = true;
+  }
+  return isError;
+}
+
+export function validateCloudStep2(cloudInstanceDetails, host_ip) {
+  let isError = false;
+  if (isEmptyString(cloudInstanceDetails.aws_name) ||
+  isEmptyString(cloudInstanceDetails.aws_db_version) || isEmptyString(cloudInstanceDetails.aws_instance_type) ||
+  isEmptyString(cloudInstanceDetails.aws_storage_type)|| isEmptyString(cloudInstanceDetails.aws_storage_size)) {
+    isError = true;
+  }
+
+  if(cloudInstanceDetails.aws_storage_type == 'io1' && isEmptyString(cloudInstanceDetails.aws_storage_IOPS)) {
+    isError = true;
+  }
+  if (isEmptyString(cloudInstanceDetails.aws_public_ip)) cloudInstanceDetails.aws_public_ip = host_ip;
+  return isError;
+}
+
+export function validateCloudStep3(cloudDBDetails, nodeInfo) {
+  let isError = false;
+  if (isEmptyString(cloudDBDetails.aws_db_name) ||
+  isEmptyString(cloudDBDetails.aws_db_username) || isEmptyString(cloudDBDetails.aws_db_password)) {
+    isError = true;
+  }
+  if (isEmptyString(cloudDBDetails.aws_db_port)) cloudDBDetails.aws_db_port = 5432;
+  if (isEmptyString(cloudDBDetails.gid)) cloudDBDetails.gid = nodeInfo['server_group']._id;
+  return isError;
+}
+
+function createData(name, value) {
+  return { name, value };
+}
+
+export function getAWSSummary(cloud, cloudInstanceDetails, cloudDBDetails) {
+  const rows1 = [
+    createData('Cloud', cloud),
+    createData('Instance name', cloudInstanceDetails.aws_name),
+    createData('Public IP', cloudInstanceDetails.aws_public_ip),
+  ];
+
+  const rows2 = [
+    createData('PostgreSQL version', cloudInstanceDetails.aws_db_version),
+    createData('Instance type', cloudInstanceDetails.aws_instance_type),
+  ];
+
+  let _storage_type = getStorageType(cloudInstanceDetails);
+
+  const rows3 = [
+    createData('Storage type', _storage_type[1]),
+    createData('Allocated storage', cloudInstanceDetails.aws_storage_size + ' GiB'),
+  ];
+  if (_storage_type[0] !== undefined) {
+    rows3.push(createData('Provisioned IOPS', _storage_type[0]));
+  }
+
+  const rows4 = [
+    createData('Database name', cloudDBDetails.aws_db_name),
+    createData('Username', cloudDBDetails.aws_db_username),
+    createData('Password', 'xxxxxxx'),
+    createData('Port',  cloudDBDetails.aws_db_port),
+  ];
+
+  return [rows1, rows2, rows3, rows4];
+}
+
+const getStorageType = (cloudInstanceDetails) => {
+  let _storage_type = 'General Purpose SSD (gp2)',
+    _io1 = undefined;
+
+  if(cloudInstanceDetails.aws_storage_type == 'gp2') _storage_type = 'General Purpose SSD (gp2)';
+  else if(cloudInstanceDetails.aws_storage_type == 'io1') {
+    _storage_type = 'Provisioned IOPS SSD (io1)';
+    _io1 = cloudInstanceDetails.aws_storage_IOPS;
+  }
+  else if(cloudInstanceDetails.aws_storage_type == 'magnetic') _storage_type = 'Magnetic';
+
+  return [_io1, _storage_type];
+};
